unit field;

interface

uses crt;

type Tfield=object
       Private

         x,y:integer;
         ex,ey:integer;
         mylabel:string;
         mytype,size:byte;
         min,max:real;
         value_string:string;
         value_integer:integer;
         value_longint:longint;

       Public

         procedure setposition(fx,fy:integer);
         procedure seterrorposition(fex,fey:integer);
         procedure setlabel(fmylabel:string);
         procedure settype(fmytype:byte);
         procedure setsize(fsize:byte);
         procedure setintervall(fmin,fmax:real);

         function getstringvalue:string;
         function getintegervalue:integer;
         function getlongintvalue:longint;

         procedure show;
         procedure read(var fdirection:integer; var fok:boolean);
         procedure seterrorline(flserror:boolean; ferrorstring:string);

         function isvalid:boolean;

       end;

implementation

procedure Tfield.setposition(fx,fy:integer);
          begin
          x:=fx;
          y:=fy;
          gotoxy(x,y);
          end;

procedure Tfield.seterrorposition(fex,fey:integer);
          begin
          ex:=fex;
          ey:=fey;
          end;

procedure Tfield.setlabel(fmylabel:string);
          begin
          mylabel:=fmylabel;
          end;

procedure Tfield.settype(fmytype:byte);
          begin
          mytype:=fmytype;
          end;

procedure Tfield.setsize(fsize:byte);
          begin
          size:=fsize;
          end;

procedure tfield.setintervall(fmin,fmax:real);
          begin
          min:=fmin;
          max:=fmax;
          end;

function Tfield.getstringvalue:string;
         begin
         getstringvalue:=value_string;
         end;

function Tfield.getintegervalue:integer;
         begin
         getintegervalue:=value_integer;
         end;

function Tfield.getlongintvalue:longint;
         begin
         getlongintvalue:=value_longint;
         end;

procedure tfield.show;
var i:integer;
          begin
          gotoxy(x,y);
          write(mylabel);
          for i:=1 to size do
              begin
              write('_');
              end;
          x:=x+length(mylabel);
          gotoxy(x,y);
          end;

procedure tfield.read(var fdirection:integer; var fok:boolean);
type halmaz= set of char;
const tovabb: halmaz=[#72,#80,#13,#27,#9];
                   {fel,le,enter,esc,tab}
      marad: halmaz=[#75,#77,#83,#8,#79,#71];
                    {bal,jobb,del,backspace,end,home}

var s,seged:string;
    ch:char;
    ok,holtart:integer;
    begin
    ok:=0;
    case mytype of
         0: s:=getstringvalue;
         1: str(getintegervalue,s);
         2: str(getlongintvalue,s);
         end;

    holtart:=length(s);
          repeat
          gotoxy(x,y);
          write(s);
          gotoxy(x+holtart,y);
          ch:=readkey;
          if ch=#0 then ch:=readkey;
          if not (ch in tovabb) then
             begin
             if not(ch in marad) then
                       begin
                       seged:=copy(s,holtart+1,length(s));
                       s:=copy(s,1,holtart);
                       s:=s+ch;
                       s:=s+seged;
                       holtart:=holtart+1;
                       end;
             if ch in marad then
                begin
                if ch=#75 then holtart:=holtart-1;
                if ch=#77 then holtart:=holtart+1;
                if ch=#8 then
                   begin
                   gotoxy(x+length(s)-1,y);
                   write('_');
                   seged:=copy(s,holtart+1,length(s));
                   s:=copy(s,1,holtart-1);
                   s:=s+seged;
                   holtart:=holtart-1;
                   end;
                if ch=#83 then
                   begin
                   gotoxy(x+length(s)-1,y);
                   write('_');
                   seged:=copy(s,holtart+2,length(s));
                   s:=copy(s,1,holtart);
                   s:=s+seged;
                   end;

                if ch=#79 then
                   begin
                   holtart:=length(s);
                   end;
                if ch=#71 then holtart:=0;
                end;
             end;

          if holtart>=size then
             begin
             holtart:=size;
             end;
          if holtart<0 then holtart:=0;

          if length(s)>=size then s:=copy(s,1,size);
          until ch in tovabb;

          fok:=true;
          if ch=#27 then
             begin
             fok:=false
             end else
             if ch=#72 then fdirection:=0 else fdirection:=1;

          case mytype of
               0:begin
                 value_string:=s;
                 end;
              1:begin
                 val(s,value_integer,ok);
                 end;
               2:begin
                 val(s,value_longint,ok);
                 end;
               end;

          if ok<>0 then
                   begin
                   seterrorline(true,'Szmot kell megadni!');
                   end else
                       begin
                       seterrorline(false,'                   ');
                       if not(isvalid) then seterrorline(true,'Nem jo az intervallum!')
                       else seterrorline(false,'                        ');
                       end;

    end;

procedure tfield.seterrorline(flserror:boolean; ferrorstring:string);
          begin
          gotoxy(ex,ey);
          write(ferrorstring);
          end;

function Tfield.isvalid:boolean;
var a:longint;
         begin
         isvalid:=false;
         case mytype of
              0:isvalid:=true;
              1: begin
                 a:=getintegervalue;
                 end;
              2: begin
                 a:=getlongintvalue;
                 end;
              end;
              if (a>=min) and (a<=max) then isvalid:=true;
         end;
begin
end.